; By Robert stling, 2005-03-05
;
; Documentation:
;
; vY5,vZ100mZ"Number: %d\n":X10(Y@Z$}1+Y!);'X~

format ELF

public fool		; int fool(char *s)
public fool_depth	; int fool_depth(void)
public fool_push	; void fool_push(int)
public fool_pop		; int fool_pop(void)

extrn printf
extrn putchar
extrn exit

section '.text' executable

fool_depth:
 mov eax,dstack+0x100
 sub eax,[dptr]
 shr eax,2
 ret

fool_push:
 sub dword[dptr],4
 mov eax,[esp+4]
 mov ecx,[dptr]
 mov [ecx],eax
 ret

fool_pop:
 mov ecx,[dptr]
 add dword[dptr],4
 mov eax,[ecx]
 ret


fool:
 push ebp
 mov ebp,esp
 push ebx
 push esi
 push edi
 mov edi,[ebp+8]
 mov esi,[dptr]
 mov ebx,[here]
.mainloop:
 movzx eax,byte[edi]
 and al,0x7f
 inc edi
 test al,al
 jz .ok
 cmp al,0x20
 jbe .mainloop
 cmp al,0x30
 jb .nonum
 cmp al,0x37
 ja .nonum
 xor ecx,ecx
.numloop:
 shl ecx,3
 sub al,0x30
 or cl,al
 mov al,[edi]
 cmp al,0x30
 jb .numdone
 cmp al,0x37
 ja .numdone
 inc edi
 jmp .numloop
.numdone:
 sub esi,4
 mov [esi],ecx
 cmp byte[mode],0
 jnz .mainloop
 call lit
 jmp .mainloop
.nonum:
 mov ecx,[dict+eax*4]
 test ecx,ecx
 jz .error
 cmp byte[immediate+eax],0
 jnz .interpret
 cmp byte[mode],0
 jz .compile
.interpret:
 call ecx
 jmp .mainloop
.compile:
 sub ecx,ebx
 sub ecx,5
 mov byte[ebx],0xe8
 mov [ebx+1],ecx
 add ebx,5
 jmp .mainloop
.error:
 mov eax,1
 jmp .quit
.ok:
 xor eax,eax
.quit:
 mov [dptr],esi
 mov [here],ebx
 pop edi
 pop esi
 pop ebx
 pop ebp
 ret

storeword:
 mov eax,[esi]
 mov ecx,[esi+4]
 add esi,8
 mov [eax],ecx
 ret

quote:
 mov ecx,[esi]
 add esi,4
.again:
 mov al,[edi]
 inc edi
 test al,al
 jz .done
 cmp al,0x22
 jz .done
 cmp al,0x5c
 jnz .no_trans
 mov al,[edi]
 inc edi
 call trans
.no_trans:
 mov [ecx],al
 inc ecx
 jmp .again
.done:
 mov byte[ecx],0
 ret

lit:
 mov eax,[esi]
 add esi,4
 mov dword[ebx],0xc704ee83
 mov byte[ebx+4],6
 mov dword[ebx+5],eax
 add ebx,9
 ret

doprintf:
 push dword[esi+16]
 push dword[esi+12]
 push dword[esi+8]
 push dword[esi+4]
 push dword[esi]
 call printf
 add esp,20
 ret

modulo:
 mov ecx,[esi]
 mov eax,[esi+4]
 add esi,4
 xor edx,edx
 div ecx
 mov [esi],edx
 ret

bitand:
 mov ecx,[esi]
 and [esi+4],ecx
 add esi,4
 ret

tick:
 sub esi,4
 movzx eax,byte[edi]
 inc edi
 mov ecx,[dict+eax*4]
 mov [esi],ecx
 ret

dofor:
 sub esi,4
 mov dword[ebx],0xc68336ff
 mov dword[ebx+4],0x243c8304
 mov dword[ebx+8],0xff007400
 mov word[ebx+12],0x240c
 add ebx,0x0a
 mov [esi],ebx
 add ebx,4
 ret

donext:
 mov eax,[esi]
 lea ecx,[ebx+1]
 sub ecx,eax
 mov [eax],cl
 sub eax,ebx
 sub al,7
 mov byte[ebx],0xeb
 mov byte[ebx+1],al
 mov byte[ebx+2],0x58
 add ebx,3
 ret
 

multiplication:
 mov eax,[esi]
 add esi,4
 mul dword[esi]
 mov [esi],eax
 ret

plus:
 mov eax,[esi]
 add [esi+4],eax
 add esi,4
 ret

comma:
 mov eax,[esi]
 add esi,4
 mov [ebx],eax
 add ebx,4
 ret

minus:
 mov eax,[esi]
 add esi,4
 sub [esi],eax
 ret

dot:
 push dword[esi]
 push dword dotstr
 call printf
 add esp,8
 add esi,4
 ret

divide:
 mov ecx,[esi]
 mov eax,[esi+4]
 add esi,4
 xor edx,edx
 div ecx
 mov [esi],eax
 ret

colon:
 movzx eax,byte[edi]
 and al,0x7f
 inc edi
 mov [dict+eax*4],ebx
 mov byte[mode],0
 ret

semicolon:
 mov byte[ebx],0xc3
 inc ebx
 mov byte[mode],1
 ret

below:
 mov eax,[esi]
 cmp [esi+4],eax
 lea esi,[esi+4]
 jb .true
 mov dword[esi],0
 ret
.true:
 mov dword[esi],-1
 ret

equal:
 mov eax,[esi]
 cmp [esi+4],eax
 lea esi,[esi+4]
 jz .true
 mov dword[esi],0
 ret
.true:
 mov dword[esi],-1
 ret

above:
 mov eax,[esi]
 cmp [esi+4],eax
 lea esi,[esi+4]
 ja .true
 mov dword[esi],0
 ret
.true:
 mov dword[esi],-1
 ret

question:
 mov dword[ebx],0x74003e83
 add ebx,4
 sub esi,4
 mov [esi],ebx
 inc ebx
 ret

fetch:
 mov eax,[esi]
 mov eax,[eax]
 mov [esi],eax
 ret

elsedo:
 mov eax,[esi]
 mov byte[ebx],0xeb
 inc ebx
 mov [esi],ebx
 inc ebx
 mov ecx,ebx
 sub ecx,eax
 dec ecx
 mov [eax],cl
 ret

thendo:
 mov eax,[esi]
 add esi,4
 lea ecx,[ebx-1]
 sub ecx,eax
 mov [eax],cl
 ret

exclusiveor:
 mov eax,[esi]
 add esi,4
 xor [esi],eax
 ret

hash:
 mov ecx,[esi]
 mov eax,2166136261
.again:
 cmp byte[ecx],0
 jz .done
 xor al,[ecx]
 inc ecx
 mov edx,16777619
 mul eax
 jmp .again
.done:
 mov [esi],eax
 ret

dup:
 mov eax,[esi]
 sub esi,4
 mov [esi],eax
 ret

swap:
 mov eax,[esi]
 mov ecx,[esi+4]
 mov [esi+4],eax
 mov [esi],ecx
 ret

drop:
 add esi,4
 ret

execute:
 add esi,4
 jmp dword[esi-4]

trans:
 cmp al,0x6e
 jnz .no
 mov al,0x0a
.no:
 ret

dom:
 add ebx,[esi]
 add esi,4
 ret

dodov:
 sub esi,4
 pop eax
 mov [esi],eax
 ret

dov:
 movzx eax,byte[edi]
 inc edi
 and al,0x7f
 mov [dict+eax*4],ebx
 mov eax,dodov-5
 sub eax,ebx
 mov byte[ebx],0xe8
 mov dword[ebx+1],eax
 add ebx,5
 ret

dob:
 push dword 0
 call exit

doc:
 movzx eax,byte[edi]
 inc edi
 and al,0x7f
 mov [dict+eax*4],ebx
 ret

doe:
 push dword[esi]
 add esi,4
 call putchar
 pop eax
 ret

dor:
 sub esi,4
 movzx eax,byte[edi]
 inc edi
 mov [esi],eax
 ret

dos:
 mov eax,[esi]
 mov cl,[esi+4]
 add esi,8
 mov [eax],cl
 ret

dof:
 mov eax,[esi]
 movzx eax,byte[eax]
 mov [esi],eax
 ret

section '.data' writeable

here	dd	dheap		; Heap pointer.
mode	dd	1		; 1 = interpret, 0 = compile
dptr	dd	dstack+0x100
dotstr	db	"%d",0

dict:
	dd	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dd	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dd	storeword
	dd	quote
	dd	lit
	dd	doprintf ; ( ... a b c str -- ... a b c str )
	dd	modulo
	dd	bitand
	dd	tick
	dd	dofor
	dd	donext
	dd	multiplication
	dd	plus
	dd	comma
	dd	minus
	dd	dot
	dd	divide
	dd	0,0,0,0,0,0,0,0
	dd	0
	dd	0
	dd	colon
	dd	semicolon
	dd	below
	dd	equal
	dd	above
	dd	question
	dd	fetch
	dd	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dd	elsedo
	dd	0
	dd	thendo
	dd	exclusiveor
	dd	hash
	dd	0
	dd	0,dob,doc,0,doe,dof,0,0,0,0,0,0,dom,0,0,0,0,dor,dos,0,0,dov
	dd	0,0,0,0
	dd	dup
	dd	swap
	dd	drop
	dd	execute
	dd	0

immediate:
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	db	0 ; storeword
	db	0 ; quote
	db	0 ; lit
	db	0 ; doprintf ; ( ... a b c str -- ... a b c str )
	db	0 ; modulo
	db	0 ; bitand
	db	0 ; tick
	db	1 ; dofor
	db	1 ; donext
	db	0 ; multiplication
	db	0 ; plus
	db	0 ; comma
	db	0 ; minus
	db	0 ; dot
	db	0 ; divide
	db	0,0,0,0,0,0,0,0
	db	0
	db	0
	db	0 ; colon
	db	1 ; semicolon
	db	0 ; below
	db	0 ; equal
	db	0 ; above
	db	1 ; question
	db	0 ; fetch
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	db	1 ; elsedo
	db	0
	db	1 ; thendo
	db	0 ; exclusiveor
	db	0 ; hash
	db	0
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	db	0 ; dup
	db	0 ; swap
	db	0 ; drop
	db	0 ; execute
	db	0


section '.bss' writeable

dstack	rd	0x100
	rd	0x20
dheap	rb	0x4000		; 16kB should be enough for user code+data


